package com.example.switchyard.myLittleService;

import java.io.StringReader;

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.stream.StreamSource;

import org.switchyard.annotations.Transformer;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class HelloServiceTransformer {
	
		@Transformer(from = "{urn:com.example.switchyard:myLittleService:0.0.1-SNAPSHOT}sayHello")
		public String transform(Element from) {
			System.out.println("Transform to String!");
			return new String(getElementValue(from, "urn:string"));
		}
		
		private String getElementValue(Element parent, String elementName) {
			String value = null;
			NodeList nodes = parent.getElementsByTagName(elementName);
			
			if(nodes.getLength() > 0) {
				value = nodes.item(0).getChildNodes().item(0).getNodeValue();
			}
			
			return value;
		}

		@Transformer(to = "{urn:com.example.switchyard:myLittleService:0.0.1-SNAPSHOT}sayHelloResponse")
		public Element transform(String name) {
			System.out.println("Transform to Element!");
			StringBuffer ackXml = new StringBuffer()
			.append("<hello:sayHelloResponse xmlns:hello=\"urn:com.example.switchyard:myLittleService:0.0.1-SNAPSHOT\">")
			.append("<return>" + name + "</return>")
			.append("</hello:sayHelloResponse>");
			
			return toElement(ackXml.toString());
		}

		private Element toElement(String string) {
			DOMResult dom = new DOMResult();
			
			try {
				TransformerFactory.newInstance().newTransformer().transform(new StreamSource(new StringReader(string)), dom);
			} catch(Exception e) {
				e.printStackTrace();
			}
			
			return ((Document)dom.getNode()).getDocumentElement();
		}
}
